//----------------------------------------------------------------
//Code Art.
//
//ļ:
//
//  : jianyi0115@163.com
//: 2008-3-15
//
//޶¼: 
//2008-8-29 ĵԶתUploadҳ
//
//----------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Reflection;
using System.Xml;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.WebPartPages;

using CodeArt.SharePoint;

[assembly: TagPrefix("CodeArt.SharePoint.SmartForm", "smartform")]
namespace CodeArt.SharePoint.SmartForm
{
    public class SmartFormWebPart : BaseSPListWebPart
    {
        private string _redirectUrl = "";
        [Personalizable(PersonalizationScope.Shared)]
        [WebBrowsable]
        [WebDisplayName("ύضUrlĬϵǰҳ棩")]
        public virtual string RedirectUrl
        {
            get { return _redirectUrl; }
            set { _redirectUrl = value; }
        }

        private string _AfterSubmitMessage = "";
        [Personalizable(PersonalizationScope.Shared)]
        [WebBrowsable]
        [WebDisplayName("ύʾϢ")]
        public virtual string AfterSubmitMessage
        {
            get { return _AfterSubmitMessage; }
            set { _AfterSubmitMessage = value; }
        }

        private string _TemplateName = "";
        [Personalizable(PersonalizationScope.Shared)]
        [WebBrowsable]
        [WebDisplayName("ģID")]
        public virtual string RenderingTemplateId
        {
            get { return _TemplateName; }
            set { _TemplateName = value; }
        }

        // ~/_CONTROLTEMPLATES/MCS_SurveyForm.ascx
        private string _ControlPath;
        [Personalizable(PersonalizationScope.Shared)]
        [WebBrowsable]
        [WebDisplayName("ģؼ·(~/_CONTROLTEMPLATES/...)")]
        public virtual string ControlTemplatePath
        {
            get { return _ControlPath; }
            set { _ControlPath = value; }
        }

        private SPControlMode _FormMode = SPControlMode.New ;
        [Personalizable(PersonalizationScope.Shared)]
        [WebBrowsable]
        [WebDisplayName("ؼģʽ")]
        public virtual SPControlMode FormMode
        {
            get { return _FormMode; }
            set { _FormMode = value; }
        }

        private int _ListItemId = 0;
        [Personalizable(PersonalizationScope.Shared)]
        [WebBrowsable]
        [WebDisplayName("бID")]
        public virtual int ListItemId
        {
            get { return _ListItemId; }
            set { _ListItemId = value; }
        }

        private SPContext m_itemContext;
        [WebPartStorage(Storage.None), Browsable(false)]
        public SPContext FormContext
        {
            get
            {
                if ((this.m_itemContext == null) && (this.Context != null))
                {

                    // SPList list = base.Web.Lists[this.ListTitle];
                    if (base.List == null)
                    {
                        throw new SPException(SPResource.GetString("ListWithTitleDoesNotExist", new object[] { base.ListName }));
                    }
                    // this.ListName = base.List.ID.ToString("B").ToUpper();
                    //ĵҳʱNewģʽתUploadҳ棬ҪFormModeδNew
                    if (this.List.BaseTemplate == SPListTemplateType.DocumentLibrary && this.FormMode == SPControlMode.New)
                        this.FormMode = SPControlMode.Edit;

                    this.m_itemContext = SPContext.GetContext(this.Context, this.GetCurrentListItemId(), this.List.ID, base.Web);
                    this.m_itemContext.FormContext.FormMode = this.FormMode;
                    //this.m_itemContext.FormContext.DisableInitialFocus = this.DisableInitialFocus;
                    this.m_itemContext.FormContext.SetFormMode(this.FormMode, true);
                }
                return this.m_itemContext;
            }
            set
            {
                this.m_itemContext = value;
            }
        }


        protected override void CreateChildControls()
        {
            base.CreateChildControls();

            if (List == null)
            {
                base.RegisterShowToolPanelControl("", "򿪹ߴ", "áбơ");
                return;
            }

            if (this.List.BaseTemplate == SPListTemplateType.DocumentLibrary && this.FormMode == SPControlMode.New)
                this.FormMode = SPControlMode.Edit;

            if (!String.IsNullOrEmpty(this.ControlTemplatePath))
                this.CreateChildByControlTemplate();
            else if (!String.IsNullOrEmpty(this.RenderingTemplateId))
                this.CreateChildByRenderingTemplate();
            else
            {
                base.RegisterShowToolPanelControl("", "򿪹ߴ", "áģ塱򡰿ؼģ塱");
            }
        }

        int GetCurrentListItemId()
        {
            int itemId = this.ListItemId;
            if ((this.FormMode == SPControlMode.Edit || this.FormMode == SPControlMode.Display)
                && itemId <= 0)
            {
                if (Page.Request.QueryString["ID"] != null)
                    itemId = Convert.ToInt32(Page.Request.QueryString["ID"]);
            }
            return itemId;
        }

        void CreateChildByControlTemplate()
        {
            try
            {
                Control templateCtl = Page.LoadControl(this.ControlTemplatePath);
                
                //ͨƸFormComponentԿFormField
                //FormFieldؼԶȡӦ
                UserControlTemplateContainer container = new UserControlTemplateContainer();
                container.RenderContext = this.FormContext;
                container.ControlMode = this.FormMode;
                container.ItemId = GetCurrentListItemId();

                container.Controls.Add(templateCtl);

               this.Controls.Add(container);
            }
            catch (Exception ex)
            {
                base.RegisterError(ex);
            }
        }

        void CreateChildByRenderingTemplate()
        {
            try
            {

                Microsoft.SharePoint.WebPartPages.ListFormWebPart form = new Microsoft.SharePoint.WebPartPages.ListFormWebPart();

                form.TemplateName = this.RenderingTemplateId;

                form.ID = this.ID + "_Form";
                form.Title = this.Title;
                form.ListName = List.ID.ToString("B").ToUpper();

                form.ControlMode = this.FormMode;

                form.ChromeType = PartChromeType.None; //ʾ
                form.ListItemId = GetCurrentListItemId();
                form.FormType = 6;
                form.DisableInitialFocus = true;

                //form.TemplateControl.FindControl("");
                this.Controls.Add(form);

            }
            catch (Exception ex)
            {
                base.RegisterError(ex);
            }
        }       

        protected override void EnsureChildControls()
        {
            try
            {
                base.EnsureChildControls();
            }
            catch (Exception ex)
            {
                base.RegisterError(ex);
            }
        }    

        protected override void OnLoad(EventArgs e)
        {
            try
            {
                base.OnLoad(e);
                this.EnsureChildControls();
            }
            catch (Exception ex)
            {
                base.RegisterError(ex);
            }
        }

        const string IsFormSaved_Context_Key = "ListFormWebPart_IsFormSaved";
        static public bool IsFormSaved
        {
            set
            {
                if (HttpContext.Current == null)
                    throw new NotSupportedException("HttpContext is null");
                HttpContext.Current.Items[IsFormSaved_Context_Key] = value;
            }
            get
            {
                if (HttpContext.Current == null)
                    throw new NotSupportedException("HttpContext is null");

                if (HttpContext.Current.Items.Contains(IsFormSaved_Context_Key))
                    return Convert.ToBoolean(HttpContext.Current.Items[IsFormSaved_Context_Key]);
                else
                    return false;
            }
        }

        /// <summary>
        /// ύɹ¼ 
        /// </summary>
        /// <param name="source"></param>
        /// <param name="args"></param>
        /// <returns></returns>
        protected override bool OnBubbleEvent(object source, EventArgs args)
        {
            if (!(args is CommandEventArgs)) return false;

            CommandEventArgs carg = args as CommandEventArgs;

            if (carg.CommandName.ToLower() != "saveitem") return false;

            if (!IsFormSaved)
            {
                this.Page.Validate();

                if (!this.Page.IsValid)
                {
                    return true;
                }

                try
                {
                    SaveData();
                }
                catch (Exception ex)
                {
                    Script.Alert(this, ex.Message);
                    return true;
                }
            }

            string redirectUrl = this.RedirectUrl;

            if (String.IsNullOrEmpty(redirectUrl))
            {
                if (Page.Request.QueryString["Source"] != null)
                    redirectUrl = "" + Page.Request.QueryString["Source"];
                else
                    redirectUrl = this.List.DefaultViewUrl;
            }

            if (!String.IsNullOrEmpty(this.AfterSubmitMessage))
            {
                Script.Alert(this, this.AfterSubmitMessage);
                Script.Redirect(this, redirectUrl);
            }
            else
            {
                Page.Response.Redirect(redirectUrl , true);
            }
            return true;
        }

        void SaveData()
        {
            SPListItem listItem;

            if (this.FormMode == SPControlMode.New)
                listItem = this.List.Items.Add();
            else
                listItem = this.FormContext.ListItem;           

            foreach (BaseFieldControl f in this.FormContext.FormContext.FieldControlCollection)
            {
                try
                {
                    //if (!f.Field.ReadOnlyField)
                    //    listItem[f.FieldName] = f.Value;
                    if (f.Field != null && !f.Field.ReadOnlyField && f.ControlMode != SPControlMode.Display)
                        f.UpdateFieldValueInItem();
                }
                catch (ArgumentException) { }
            }

            //update contenttype id
            string ctId = HttpContext.Current.Request.QueryString["ContentTypeId"];

            if (ctId != null)
            {
                listItem["ContentTypeId"] = ctId;
            }
            else if (List.ContentTypes.Count >= 1)
            {
                listItem["ContentTypeId"] = List.ContentTypes[0].Id.ToString();
            }

            listItem.Update();
        }

    }

    public class UserControlTemplateContainer : FormComponent
    {

    }
}